(function () {
    "use strict";

    angular.module('core').controller('tarefaController', controller);
    controller.$inject = ['$scope', '$q', '$stateParams', '$alert', 'tarefaService', 'lookupService'];

    function controller($scope, $q, $stateParams, $alert, tarefaService, lookupService) {
        $scope.initializeLayout('Tarefas');

        //[Inicializa objetos]
        $scope.state = {
            data: [],
            carregando: false,
            carregandoMais: false,
            salvando: false,
            vazio: false,
            completo: false,
            count: 0,
            filtro: {
                ativo: false,
                args: {}
            }
        };
        $scope.popups = {
            add: {
                ativo: false,
                data: {},
                save: function () {
                    $scope.state.salvando = true;
                    tarefaService
                        .save($scope.popups.add.data)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ title: $scope.Title, text: response.Message });
                                } else {
                                    $scope.popups.add.ativo = false;
                                    $scope.popups.add.data = {};
                                    $scope.refresh();

                                    if (action === $scope.popups.add.saveAction.saveAndNew) {
                                        $scope.popups.add.steps.index = 0;
                                        $scope.popups.add.toggle();
                                    }
                                }
                                $scope.state.salvando = false;
                            },
                            function (_error) {
                                $scope.state.salvando = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                saveAction: { save: 0, saveAndNew: 1 },
                toggle: function () {
                    $scope.popups.add.ativo = !$scope.popups.add.ativo;
                    if ($scope.popups.add.ativo) {
                        $scope.popups.add.prepareNew();
                    }
                    else {
                        $scope.popups.add.steps.index = 0;
                    }
                },
                prepareNew: function () {
                    tarefaService
                        .prepareNew()
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                    $scope.popups.edit.ativo = false;
                                } else {
                                    $scope.popups.add.data = response.Data;
                                    $scope.popups.add.ativo = true;
                                }
                            },
                            function (_error) {
                                $scope.popups.edit.ativo = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                prepare: function () {
                    tarefaService
                        .prepare($scope.popups.add.data)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                } else {
                                    $scope.popups.add.data = response.Data;
                                }
                            },
                            function (_error) {
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                steps: {
                    index: 0,
                    count: 2,
                    next: function () {
                        if ($scope.popups.add.steps.index < ($scope.popups.add.steps.count - 1))
                            $scope.popups.add.steps.index++;
                    },
                    prior: function () {
                        if ($scope.popups.add.steps.index > 0)
                            $scope.popups.add.steps.index--;
                    },
                },
            },
        };
        $scope.auxiliar = {
            categoriaTarefa: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllCategoriaTarefa({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                }
            },
            grupoUsuario: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllGrupoUsuario({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                }
            },
            usuario: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllUsuario({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                }
            },
            empresa: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllEmpresa({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                }
            },
            contato: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllContato({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                }
            },
            chamado: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllChamado({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                }
            },
            demanda: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllDemanda({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                }
            },
            projeto: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllProjeto({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                }
            },
            status: {
                data: [],
                getAll: async () => {
                    try {
                        var response = await tarefaService.getDistinctStatus();

                        if (response.Status < 0) {
                            $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            console.error(response);
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.auxiliar.status.data);
                        }
                    } catch (error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(err)
                    }
                },
                mestre: {
                    naoIniciado: 0,
                    iniciado: 1,
                    concluido: 2,
                    cancelado: 3,
                    aguardando: 4,
                    reprovado: 5,
                    suspenso: 6
                }
            },
            classeStatus: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllClasseStatus({ chaves: chaves, filtro: { Classe: { ID: "7A0B9A80-B76D-49AA-8626-23A769AD5E0F" } } })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                }
            },
            modeloProcesso: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllModeloProcesso({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                }
            },
            situacao: {
                indicaNormal: function (item) {
                    return (!item?.UltimoAcompanhamento?.IndicaConcluido) &&
                        (new Date(item?.UltimoAcompanhamento?.Previsao?.TerminoEm).setHours(0, 0, 0, 0) > $scope.tools.date.hoje.setHours(0, 0, 0, 0))
                },
                indicaAtraso: function (item) {
                    return (!item?.UltimoAcompanhamento?.IndicaConcluido) &&
                        (new Date(item?.UltimoAcompanhamento?.Previsao?.TerminoEm).setHours(0, 0, 0, 0) < $scope.tools.date.hoje.setHours(0, 0, 0, 0))
                },
                indicaHoje: function (item) {
                    return (!item?.UltimoAcompanhamento?.IndicaConcluido) &&
                        (new Date(item?.UltimoAcompanhamento?.Previsao?.TerminoEm).setHours(0, 0, 0, 0) === $scope.tools.date.hoje.setHours(0, 0, 0, 0))
                },
            },
        };
        $scope.presets = {
            EmAtraso: function () {
                $scope.state.filtro.args.filtro.UltimoAcompanhamento.IndicaConcluido = false;
                $scope.state.filtro.args.filtroAte.UltimoAcompanhamento.Previsao.TerminoEm = new Date($scope.tools.date.hoje.setSeconds($scope.tools.date.hoje.getSeconds() - 1));
            },
            AberturaHoje: function () {
                $scope.state.filtro.args.filtroDe.CriadoEm = $scope.tools.date.hoje;
                $scope.state.filtro.args.filtroAte.CriadoEm = new Date($scope.tools.date.hoje.setHours(23, 59, 59));
            },
            InicioHoje: function () {
                $scope.state.filtro.args.filtroDe.UltimoAcompanhamento.Previsao.InicioEm = $scope.tools.date.hoje;
                $scope.state.filtro.args.filtroAte.UltimoAcompanhamento.Previsao.InicioEm = new Date($scope.tools.date.hoje.setHours(23, 59, 59));
            },
            TerminoHoje: function () {
                $scope.state.filtro.args.filtroDe.UltimoAcompanhamento.Previsao.TerminoEm = $scope.tools.date.hoje;
                $scope.state.filtro.args.filtroAte.UltimoAcompanhamento.Previsao.TerminoEm = new Date($scope.tools.date.hoje.setHours(23, 59, 59));
            }
        };

        //[Inicializa funcões]
        $scope.initialize = async () => {
            await $scope.clearFilter();

            const _filtro = $scope.localStorage.getItem('state.filtro.args');
            if (_filtro) {
                await angular.copy(_filtro, $scope.state.filtro.args);
            }

            if ($stateParams.id)
                $scope.popups.edit.toggle($stateParams.id);

            $scope.refresh();
        };

        $scope.beforeRefresh = async () => {
            await $scope.convertFilter();
        };
        $scope.afterRefresh = async () => {
            /* trata mudanças no filtro */
            $scope.state.filtro.original.sortExpression = $scope.state.filtro.args.sortExpression;
            $scope.state.filtro.original.skip = $scope.state.filtro.args.skip;
            $scope.state.filtro.original.take = $scope.state.filtro.args.take;

            $scope.state.filtro.hasChanges = (angular.toJson($scope.state.filtro.original) !== angular.toJson($scope.state.filtro.args));

            /* armazena na localstorage para quando inicializar a página */
            $scope.localStorage.setItem('state.filtro.args', $scope.state.filtro.args);
        };
        $scope.refresh = async () => {
            try {
                await $scope.beforeRefresh();
                $scope.state.filtro.ativo = false;
                await $scope.innerRefresh();
                await $scope.afterRefresh();
            }
            catch (error) {
                console.error(error);
                $scope.clearFilter();
            } finally {
                $scope.$digest();
            }
        };
        $scope.clear = async () => {
            await $scope.clearFilter();
            $scope.refresh();
        };

        $scope.toggleFilter = async () => {
            $scope.state.filtro.ativo = !$scope.state.filtro.ativo;
        };
        $scope.convertFilter = async () => {
            /* prepara o filtro. Ex: in list de status */
        };
        $scope.clearFilter = async () => {
            $scope.state.filtro = {
                args: {
                    chaves: '',
                    filtro: {
                        UltimoAcompanhamento: {
                            IndicaConcluido: false
                        }
                    },
                    filtroDe: {
                        UltimoAcompanhamento: {
                            Previsao: {
                                InicioEm: null,
                                TerminoEm: null
                            }
                        }
                    },
                    filtroAte: {
                        UltimoAcompanhamento: {
                            Previsao: {
                                InicioEm: null,
                                TerminoEm: null
                            }
                        }
                    },
                    filtroEm: null,
                    sortExpression: '[CriadoEm] desc, [Codigo]',
                    skip: 0,
                    take: 20,
                },
                original: {},
                hasChanges: false
            };

            await $scope.convertFilter();
            await angular.copy($scope.state.filtro.args, $scope.state.filtro.original);
        };

        $scope.innerRefresh = async () => {
            await $scope.auxiliar.status.getAll();

            await $scope.getAll();
            await $scope.count();
        };
        $scope.getAll = async () => {
            try {
                $scope.state.filtro.args.skip = 0;
                $scope.state.carregando = true;
                $scope.state.completo = false;
                $scope.state.vazio = false;

                const response = await tarefaService.getAll($scope.state.filtro.args);
                if (response.Status < 0) {
                    $scope.tools.toastr.error(response.Message, 'Serviço');
                } else {
                    angular.copy(angular.fromJson(response.Data), $scope.state.data);
                }
                $scope.state.vazio = ($scope.state.data == 0);
            }
            catch (err) {
                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                console.error(err)
            }
            finally {
                $scope.state.carregando = false;
            }
        };
        $scope.count = async () => {
            try {
                const response = await tarefaService.count($scope.state.filtro.args);

                if (response.Status < 0) {
                    $scope.tools.toastr.error(response.Message, 'Serviço');
                } else {
                    $scope.state.count = response.Data;
                }
            }
            catch (err) {
                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                console.error(err)
            } finally {
            }
        };
        $scope.getMore = async () => {
            if (!$scope.state.carregandoMais && !$scope.state.carregando && !$scope.state.completo && !($scope.state.data == 0)) {
                try {
                    $scope.state.carregandoMais = true;
                    $scope.state.filtro.args.skip += $scope.state.filtro.args.take;

                    let response = await tarefaService.getAll($scope.state.filtro.args)
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                    } else {
                        $scope.state.data = $scope.state.data.concat(response.Data);
                        $scope.state.completo = (response.Data == 0);
                    }
                } catch (err) {
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    console.error(err);
                } finally {
                    $scope.state.carregandoMais = false;
                    $scope.$digest();
                }
            }
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();